#ifdef ASCON_PRINT_STATE

#include "printstate.h"

#include <inttypes.h>
#include <stdio.h>
#include <string.h>

#ifndef WORDTOU64
#define WORDTOU64
#endif

#ifndef U64BIG
#define U64BIG
#endif

void printword(const char* text, const uint64_t x) {
  printf("%s=%016" PRIx64, text, U64BIG(WORDTOU64(x)));
}

void printstate(const char* text, const state_t* s) {
  printf("%s:", text);
  for (int i = strlen(text); i < 17; ++i) printf(" ");
  printword(" x0", s->x[0]);
  printword(" x1", s->x[1]);
  printword(" x2", s->x[2]);
  printword(" x3", s->x[3]);
  printword(" x4", s->x[4]);
#ifdef ASCON_PRINT_BI
  printf(" ");
  printf(" x0=%016" PRIx64, s->x[0]);
  printf(" x1=%016" PRIx64, s->x[1]);
  printf(" x2=%016" PRIx64, s->x[2]);
  printf(" x3=%016" PRIx64, s->x[3]);
  printf(" x4=%016" PRIx64, s->x[4]);
#endif
  printf("\n");
}

#endif
